#include <stdio.h>
#include <stdlib.h>

/*
  ǂVCLTHREAD_PRIORITY_IDLẼXbhƂ̑炵B
  TThreadIɕێe[uA
  ITHREAD_PRIORITY_NORMALɂ鎖ƂB
*/

/* ThreadPriorityTable of VCL */
unsigned char vcl_thread_priority_table[4*7] = 
{
	0xf1,0xff,0xff,0xff,
	0xfe,0xff,0xff,0xff,
	0xff,0xff,0xff,0xff,
	0x00,0x00,0x00,0x00,
	0x01,0x00,0x00,0x00,
	0x02,0x00,0x00,0x00,
	0x0f,0x00,0x00,0x00,
};

int fixvcl(char *path)
{
	long p, l;
	int f = 0;
	FILE *fp = 0;
	unsigned char *buf = 0;
#define FINALLY(r) { if (buf) free(buf); if (fp) fclose(fp); return r; }
	fp = fopen(path, "rb");
	if (fp == 0) FINALLY(1);
	if (fseek(fp, 0, SEEK_END) != 0) FINALLY(1);
	l = ftell(fp);
	if (l < 1) FINALLY(1);
	buf = malloc(l + 0x200);
	if (buf == 0) FINALLY(1);
	memset(buf, 0, l + 0x200);
	if (fseek(fp, 0, SEEK_SET) != 0) FINALLY(1);
	l = fread(buf, 1, l, fp);
	fclose(fp); fp = 0;
	if (l < 0x200) FINALLY(1);

	if (buf[0] != 0x4d || buf[1] != 0x5a) FINALLY(1);

	for (p = 0; p + sizeof(vcl_thread_priority_table) <= l; p += 4)
	{
		if (memcmp(buf + p, vcl_thread_priority_table, sizeof(vcl_thread_priority_table)) != 0) continue;
		f++;
		/* if (f == 1) */
		{
			printf("patched %s:%08x\n", path, p);
			/* change IDLE(0xfffffff1) to NORMAL(0x00000000) */
			memcpy(buf + p, vcl_thread_priority_table + 4 * 3, 4);
		}
	}
	if (f == 0)
	{
		printf("not proceeded %s\n", path);
		FINALLY(0);
	}

	fp = fopen(path, "wb");
	if (fp == 0) FINALLY(1);
	fwrite(buf, 1, l, fp);

	printf("finished %s\n", path);

	FINALLY(0);
}

int main(int argc, char **argv)
{
	int i;
	for (i = 1; i < argc; i++) fixvcl(argv[i]);
	return 0;
}
